package com.steerinfo.baseinfo.meterbasematterinfo.controller;

import com.steerinfo.baseinfo.dto.SelectMatterDemo;
import com.steerinfo.baseinfo.meterbasecustomersupplier.model.MeterBaseCustomerSupplier;
import com.steerinfo.baseinfo.meterbasematterinfo.model.MeterBaseMatterInfo;
import com.steerinfo.baseinfo.meterbasematterinfo.service.IMeterBaseMatterInfoService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseMatterInfo RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-10-14 08:40
 * 类描述
 * 修订历史：
 * 日期：2020-10-14
 * 作者：generator
 * 参考：
 * 描述：MeterBaseMatterInfo RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasematterinfos")
@Api(value = "/${api.version}/meterbasematterinfos", tags = "计量物料配置 - MeterBaseMatterInfoController")
public class MeterBaseMatterInfoController extends BaseRESTfulController {

    @Autowired
    IMeterBaseMatterInfoService meterBaseMatterInfoService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfo:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseMatterInfo> list = meterBaseMatterInfoService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseMatterInfo> list = meterBaseMatterInfoService.queryAll(parmas);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfo:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseMatterInfo> list = meterBaseMatterInfoService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseMatterInfo对象创建")
    @ApiImplicitParam(name = "meterBaseMatterInfo", value = "详细实体meterBaseMatterInfo", required = true, dataType = "MeterBaseMatterInfo")
    //@RequiresPermissions("meterbasematterinfo:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseMatterInfo model) {
        try {
            String msg = meterBaseMatterInfoService.checkandadd(model);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseMatterInfo meterBaseMatterInfo = meterBaseMatterInfoService.getById(id);
            return success(meterBaseMatterInfo);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseMatterInfo信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseMatterInfo", value = "详细实体meterBaseMatterInfo", required = true, dataType = "MeterBaseMatterInfo")
    })
    //@RequiresPermissions("meterbasematterinfo:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseMatterInfo model) {
        try {
            String msg = meterBaseMatterInfoService.checkandupdate(id, model);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseMatterInfoService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "启用标识符", notes = "根据传过来的MeterBaseMatterInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseMatterInfo", value = "详细实体MeterBaseMatterInfo", required = true, dataType = "MeterBaseMatterInfo")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody List<MeterBaseMatterInfo> models) {
        try {
            String msg = meterBaseMatterInfoService.Recovery(models);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "废除标识符", notes = "根据传过来的MeterBaseSpotInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseSpotInfo", value = "详细实体MeterBaseSpotInfo", required = true, dataType = "MeterBaseSpotInfo")
    })
    //@RequiresPermissions("combaseinfo:update")
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseMatterInfo> models) {
        try {
            String msg = meterBaseMatterInfoService.abolish(models);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "可用期限皮", notes = "根据传过来的MeterBaseMatterInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseMatterInfo", value = "详细实体MeterBaseMatterInfo", required = true, dataType = "MeterBaseMatterInfo")
    })
    @Transactional
    @PostMapping(value = "/useTare")
    public RESTfulResult useTare(@RequestBody List<MeterBaseMatterInfo> models) {
        try {
            String msg = meterBaseMatterInfoService.useTare(models);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "取消期限皮", notes = "根据传过来的MeterBaseSpotInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseSpotInfo", value = "详细实体MeterBaseSpotInfo", required = true, dataType = "MeterBaseSpotInfo")
    })
    //@RequiresPermissions("combaseinfo:update")
    @Transactional
    @PostMapping(value = "/unTare")
    public RESTfulResult unTare(@RequestBody List<MeterBaseMatterInfo> models) {
        try {
            String msg = meterBaseMatterInfoService.unTare(models);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "可用附加重量", notes = "根据传过来的MeterBaseMatterInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseMatterInfo", value = "详细实体MeterBaseMatterInfo", required = true, dataType = "MeterBaseMatterInfo")
    })
    @Transactional
    @PostMapping(value = "/useAddWeight")
    public RESTfulResult useAddWeight(@RequestBody List<MeterBaseMatterInfo> models) {
        try {
            String msg = meterBaseMatterInfoService.useAddWeight(models);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "取消附加重量", notes = "根据传过来的MeterBaseSpotInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseSpotInfo", value = "详细实体MeterBaseSpotInfo", required = true, dataType = "MeterBaseSpotInfo")
    })
    //@RequiresPermissions("combaseinfo:update")
    @Transactional
    @PostMapping(value = "/unAddWeight")
    public RESTfulResult unAddWeight(@RequestBody List<MeterBaseMatterInfo> models) {
        try {
            String msg = meterBaseMatterInfoService.unAddWeight(models);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "关联查询", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:view")
    @Transactional
    @GetMapping(value = "/correlation")
    public RESTfulResult correlation(@RequestParam Integer pageNum, Integer pageSize) {
        PageList<MeterBaseMatterInfo> pageInfo = meterBaseMatterInfoService.selectcorrelation(pageNum, pageSize);
        return success(pageInfo);
    }


    @ApiOperation(value = "物料时间、预报超差关联查询", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:view")
    @Transactional
    @GetMapping(value = "/diffscorrelation")
    public RESTfulResult diffscorrelation(@RequestParam Integer pageNum, Integer pageSize) {
        PageList<MeterBaseMatterInfo> pageInfo = meterBaseMatterInfoService.diffscorrelation(pageNum, pageSize);
        return success(pageInfo);
    }

    @ApiOperation(value = "物料时间关联查询", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:view")
    @Transactional
    @GetMapping(value = "/timecorrelation")
    public RESTfulResult timecorRelation(@RequestParam Integer pageNum, Integer pageSize) {
        PageList<MeterBaseMatterInfo> pageInfo = meterBaseMatterInfoService.timecorRelation(pageNum, pageSize);
        return success(pageInfo);
    }

    @ApiOperation(value = "业务二维码获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfo:view")
    @GetMapping(value = "/selectByMeterCode")
    public RESTfulResult selectByMeterCode(@RequestParam Integer pageNum, Integer pageSize) {
        PageList<MeterBaseMatterInfo> list = meterBaseMatterInfoService.selectByMeterCode(pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "查询按钮", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:view")
    @Transactional
    @PostMapping(value = "/listLike")
    public RESTfulResult listLike(@RequestBody SelectMatterDemo model) {
        try {
            PageList<MeterBaseMatterInfo> pageInfo = meterBaseMatterInfoService.listLike(model);
            return success(pageInfo);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "二维码查询物料按钮", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfo:view")
    @Transactional
    @PostMapping(value = "/listMeterCode")
    public RESTfulResult listMeterCode(@RequestBody SelectMatterDemo model) {
        try {
            PageList<MeterBaseMatterInfo> pageInfo = meterBaseMatterInfoService.listMeterCode(model);
            return success(pageInfo);
        } catch (
                Exception ex) {
           ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterBaseMatterInfo对象创建")
    @ApiImplicitParam(name = "MeterBaseMatterInfo", value = "详细实体MeterBaseMatterInfo", required = true, dataType = "MeterBaseMatterInfo")
    @PostMapping(value = "/doUpdateBeltType")
    public RESTfulResult doUpdateBeltType(@RequestBody List<MeterBaseMatterInfo> model) {
        try {
            int no = meterBaseMatterInfoService.doUpdateBeltType(model);
            return success(no);
        } catch (
                Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取打印特定的物料", notes = "根据参数进行查询")
    @GetMapping(value = "/selectPrint/")
    public RESTfulResult selectPrint() {
        RESTfulResult rm = failed();
        try {
            List<MeterBaseMatterInfo> rows = meterBaseMatterInfoService.selectPrint();
            if (rows == null || rows.size() <= 0) {
                return failed("无发货单位信息！！");
            }
            return success(rows);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
